<template>
  <div class="app-container">
    <!-- 查询表单 -->
    <el-form :model="listQuery" size="small" :inline="true" label-position="top">
      <el-row :gutter="20">
        <el-col :span="6">
          <el-form-item label="物流公司名称">
            <el-input clearable placeholder="物流公司名称" v-model="listQuery.logisticsName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="状态">
            <el-select v-model="listQuery.status" clearable placeholder="状态" style="width: 100%">
              <el-option :key="item.type" v-for="item in statusList" 
                :label="item.name" :value="item.type">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row :gutter="20">
        <el-col :span="6">
          <el-form-item label="搜索">
            <el-button style="width: 100%;" type="primary" icon="el-icon-search"
              @click="handleQuery">搜索</el-button>
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="重置">
            <el-button style="width: 100%;" icon="el-icon-refresh" type="primary"
              @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <!-- 操作按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" class="editButton" size="small" icon="el-icon-plus"
          @click="handleCreate">添加</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" icon="el-icon-download" size="small" @click="handleDownload">导出</el-button>
      </el-col>
    </el-row>

    <!-- 查询结果 -->
    <div class="border-card">
      <el-table height="450" size="small" :data="list" v-loading="listLoading"
        element-loading-text="正在查询中。。。" border fit highlight-current-row>

        <el-table-column type="index" label="序号" header-align="center" align="center">
        </el-table-column>

        <el-table-column align="center" min-width="150px" label="物流公司名称" prop="logisticsName">
        </el-table-column>

        <el-table-column align="center" min-width="120px" label="快递查询代码" prop="queryCode">
        </el-table-column>

        <el-table-column align="center" min-width="120px" label="菜鸟代码" prop="rookieCode">
        </el-table-column>

        <el-table-column align="center" min-width="80px" label="状态">
          <template slot-scope="props">
            <span v-if="props.row.status == 0" style="color: #67C23A;font-weight: bold;">启用</span>
            <span v-if="props.row.status == 1" style="color: #E6A23C;font-weight: bold;">停用</span>
          </template>
        </el-table-column>

        <el-table-column align="center" label="操作" width="280" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button type="text" icon="el-icon-edit" class="editText" size="small"
              @click="handleUpdate(scope.row)">编辑</el-button>
            <el-button v-if="scope.row.status == 1" type="text" icon="el-icon-circle-check" 
              class="openText" size="small" @click="changeState(scope.row.id, scope.row.status)">启用</el-button>
            <el-button v-if="scope.row.status == 0" type="text" icon="el-icon-circle-close" 
              class="closeText" size="small" @click="changeState(scope.row.id, scope.row.status)">停用</el-button>
            <el-button type="text" icon="el-icon-delete" class="deleteText" size="small"
              @click="handleDelete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <!-- 分页 -->
      <div class="pagination-container">
        <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
          :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
          layout="total, sizes, prev, pager, next, jumper" :total="total">
        </el-pagination>
      </div>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible"
      width="70%">
      <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left"
        label-width="110px" style='margin: 0 50px;'>
        <el-form-item label="物流公司名称" prop="logisticsName">
          <el-input v-model="dataForm.logisticsName" placeholder="请输入物流公司名称"></el-input>
        </el-form-item>
        <el-form-item label="快递查询代码" prop="queryCode">
          <el-input v-model="dataForm.queryCode" placeholder="请输入快递查询代码"></el-input>
        </el-form-item>
        <el-form-item label="菜鸟代码" prop="rookieCode">
          <el-input v-model="dataForm.rookieCode" placeholder="请输入菜鸟代码"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listExpress, createExpress, updateExpress, deleteExpress, setState } from '@/api/express'
import waves from '@/directive/waves'

export default {
  directives: { waves },
  data() {
    return {
      list: [],
      total: 0,
      listLoading: false,
      statusList: [
        { type: 0, name: '启用' },
        { type: 1, name: '停用' }
      ],
      listQuery: {
        page: 1,
        limit: 10,
        logisticsName: '',
        status: ''
      },
      dataForm: {
        logisticsName: undefined,
        queryCode: undefined,
        rookieCode: undefined,
        remarks: undefined
      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑物流公司',
        create: '添加物流公司'
      },
      rules: {
        logisticsName: [{ required: true, message: '物流公司名称不能为空', trigger: 'blur' }],
        queryCode: [{ required: true, message: '快递查询代码不能为空', trigger: 'blur' }],
        rookieCode: [{ required: true, message: '菜鸟代码不能为空', trigger: 'blur' }]
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    resetQuery() {
      this.listQuery = {
        page: 1,
        limit: 10,
        logisticsName: '',
        status: ''
      }
      this.handleQuery()
    },
    getList() {
      this.listLoading = true
      listExpress(this.listQuery).then(response => {
        this.list = response.data.data.items
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleQuery() {
      this.listQuery.page = 1
      this.getList()
    },
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.getList()
    },
    handleCurrentChange(val) {
      this.listQuery.page = val
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        logisticsName: undefined,
        queryCode: undefined,
        rookieCode: undefined,
        remarks: undefined
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          createExpress(this.dataForm).then(response => {
            this.dialogFormVisible = false
            this.$notify({
              title: '成功',
              message: '创建成功',
              type: 'success',
              duration: 2000
            })
            this.getList()
          })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateExpress(this.dataForm).then(() => {
            this.dialogFormVisible = false
            this.$notify({
              title: '成功',
              message: '更新成功',
              type: 'success',
              duration: 2000
            })
            this.getList()
          })
        }
      })
    },
    handleDelete(row) {
      this.$confirm('确认删除吗？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteExpress({ id: row.id }).then(response => {
          this.$notify({
            title: '成功',
            message: '删除成功',
            type: 'success',
            duration: 2000
          })
          this.getList()
        })
      }).catch(() => { })
    },
    handleDownload() {
      window.location.href = process.env.BASE_API + '/logistics-company/export'
    },
    changeState(id, status) {
      setState({ id: id, status: status }).then(response => {
        this.$notify({
          title: '成功',
          message: '状态修改成功',
          type: 'success',
          duration: 2000
        })
        this.getList()
      })
    }
  }
}
</script>